###############################################################################
# BizDesign ImageFolio Lite Edition 4.2 (Four-dot-Two)
###############################################################################
#
#          ##          ###        VERSION       :  4.2
#        ####        ##   ##      RELEASED ON   :  02/15/2007
#      ##  ##              ##     LAST MODIFIED :  02/15/2007
#    ##########          ##       
#          ##   ###    ##         
#          ##   ###  ########     
#
###############################################################################
# Released by BizDesign, Inc.
# written by Dirk Koppers and Greg Raaum of BizDesign
#
# Purchasing :  http://imagefolio.com/purchase/
# Support    :  http://imagefolio.com/support/
# Phone      :  (214) 642-9787
# Email      :  sales@bizdesign.com
###############################################################################
# COPYRIGHT AND LICENSE INFORMATION :
#
# Copyright (c) 1999-2007 BizDesign, Inc. All rights reserved.
#
# Selling or distributing the code for this program without prior written
# consent is expressly forbidden.
#
# One licensed copy of the program may reside on a single server, in use by a
# single domain.  For each installed instance of the program, a separate
# license is required.
#
# Licensed users may alter or modify this software, at their own risk, of
# course.  They may also hire others to modify their own copy of the code, as
# long as the code is not transferred to or retained by the individual who is
# hired (unless he/she is also a license holder). Although license-holders
# may modify the code for their use, modified code may NOT be resold or
# distributed.
#
# THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED WARRANTIES,
# INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
# FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL BIZDESIGN,
# INC. OR ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR
# BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER
# IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
# POSSIBILITY OF SUCH DAMAGE.
#
# BizDesign, Inc. is not liable for any conduct associated with image gallery
# activity, nor for any binary media posted using this program, including but
# not imited to images, photographs, movies, and clipart.
#
# The user must assume the entire risk of using the program.  Although this
# program has been thoroughly tested on BizDesign's servers, BizDesign does not
# warrant that it works on all servers and will not be held liable for anything,
# including but not limited to, misusage, error, or loss of data.  ANY
# LIABILITY OF THE SELLER WILL BE LIMITED EXCLUSIVELY TO PRODUCT REPLACEMENT
# OR REFUND OF PURCHASE PRICE.  Use at your own risk!
###############################################################################
# Do not modify below this line unless you know what you are doing.
###############################################################################

eval qq{ require "$libpath/if_web_get.pl"; } or &exit_install_ic($@);

sub install_ic_in_progress {
   $install_ic_in_progress = qq|
   <script language="javascript">
   var now = new Date();
   var downloadAnimation = new Image();
   downloadAnimation.src = 'http://www.imagefolio.com/ImageConvert/images/install_in_progress.gif';
   function install_ic_in_progress () {
      var agt=navigator.userAgent.toLowerCase();
      var is_major = parseInt(navigator.appVersion); 
      var is_ie   = ((agt.indexOf("msie") != -1) && (agt.indexOf("opera") == -1));
      var is_ie3  = (is_ie && (is_major < 4));
      var is_ie4  = (is_ie && (is_major == 4) && (agt.indexOf("msie 5")==-1) && (agt.indexOf("msie 6") == -1)); 
      var is_ie5up  = (is_ie  && !is_ie3 && !is_ie4); 
      if (is_ie5up){
         setTimeout("document.images['downloadImg'].src = downloadAnimation.src",10);
      }
      location.href="$imagefolio_url?imageconvert=install&finish=2&file=$FORM{'file'}&this_reg=$FORM{'this_reg'}";
   }
   </script>|;
}

sub install_done_ic {
   my $close_ic_button = &close_ic_button;
   &die_ic("<b>ImageConvert installation: Installation done</b><br>The installation of ImageConvert is finished. Now try it out and see if it works by uploading an image. Make sure you have a look at the various ImageConvert settings in you admin_config.pl like size, sharpness, contrast etc. of your uploaded image files.", $close_ic_button);
}


sub install_ic_in {
   &check_dir_ic;
   &which_ic;
   if ($FORM{'finish'} == 2) {
      $ic_query = &admin_decrypt("$FORM{'file'}", "file");
   }
   else {
      $ic_query = "ic_reg=$ic_reg";
      $ic_query .= "&auto=1";
      $ic_query .= "&operating_system=$info_OS";
      $ic_query .= "&os_version=$info_OSv";
      $ic_query .= "&kernel=$info_PROC_RELEASE";
      $ic_query .= "&machine=$info_MACHINE";
      $ic_query .= "&processor_type=$info_PROCESSOR";
      $ic_query .= "&return_url=$imagefolio_url";
      $ic_query .= "&ct=$current_time";
      $ic_query .= "&from=pro4$no_imageconvert_watermark";
      $ic_query .= "&zipsupport=$zipsupport";
      $ic_query =~ s/([^a-zA-Z0-9])/"%" . sprintf("%2x", ord($1))/ge;
      $ic_query = "http://www.imagefolio.com/ImageConvert/locate/?$ic_query";
   }
   if ($proxy_address) {
      $incorrect_proxy = qq|The proxy info you supplied below seems to be incorrect. |;
   }

   if (!$FORM{'finish'}) {
      my $ic_respond = &if_web_get($ic_query);
      my ($ic_respond_message, $ic_respond_button, $ic_respond_file, $ic_respond_reg, $ic_imagefolio_respond) = split(/~/, $ic_respond);
      if (!$ic_respond_message) {
         $incorrect_proxy = qq|<b>ImageConvert installation: Proxy/Firewall setup</b><br>${incorrect_proxy}At this moment we 
            could not connect to www.imagefolio.com to download the required files. Make sure you fill in the proxy info 
            for the server that ImageFolio is installed on or continue with the 
            <a href="$imagefolio_url?imageconvert=manual_install">manual</a> installation.|;
         my $proxy_button = &proxy_ic_button($proxy_address, $proxy_port);
         &die_ic($incorrect_proxy, $proxy_button);
      }
      elsif ($ic_imagefolio_respond ne "ImageFolio") {
         my $incorrect_responds = qq|<b>ImageConvert installation: Automatic install</b><br>At this moment we could not 
            connect to www.imagefolio.com to download the required files. Please try again later or continue with the 
            manual installation.|;
         my $install_manual_ic_button = &install_manual_ic_button;
         &die_ic($incorrect_responds, $install_manual_ic_button);
      }
      elsif ($ic_respond_button) {
         $this_respond_button = &{$ic_respond_button}($ic_respond_file, $ic_respond_reg);
      }
      &die_ic("$ic_respond_message", $this_respond_button);
   }
   elsif ($FORM{'finish'} == 1) {
      my $onload = qq| onLoad="install_ic_in_progress()"|;
      &install_ic_in_progress;
      &die_ic("<b>ImageConvert installation: In progress</b><br>We are now installing ImageConvert on your server. Please stand by, this can take a couple of seconds (or minutes).", "<tr><td align=\"center\"><img name=\"downloadImg\" src=\"http://www.imagefolio.com/ImageConvert/images/install_in_progress.gif\" border=0></td></tr>", $onload, $install_ic_in_progress);
   }
   else {
      sleep 5;
      &get_ic;
      &set_reg_ic($FORM{'this_reg'});
      my ($ic_installed, $ic_working, $ic_why) = split(/~/, &do_load_ic);
      if ($ic_working eq "No") {
         &empty_dir_ic;
         my $install_manual_ic_button = &install_manual_ic_button;
         &die_ic("<b>ImageConvert installation: Installation failed</b><br>We were not able to install ImageConvert at this moment. Please try to install it manually.<br><font color=\"#cccccc\" size=1>Error: Couldn't execute imageConvert ($ic_why)</font>", $install_manual_ic_button);
      }
      else {
         &install_done_ic;
      }
   }
}

sub finish_install_ic_button {
   my ($ic_respond_file, $ic_respond_reg) = @_;
   my $ic_output = qq|<tr><td align="center"><input type="button" class="ic_button" value="Go Back" onClick="history.go(-1)"> <input type="submit" class="ic_button" value="Finish Installation" onClick='this.value="Processing ...";location.href="$imagefolio_url?imageconvert=install&finish=1&file=$ic_respond_file&this_reg=$ic_respond_reg";'></td></tr>|;
   return $ic_output;
}

sub empty_dir_ic {
   opendir(IC_DIR,"$data_directory/ic");
   @files = readdir(IC_DIR);
   closedir(IC_DIR);
   foreach $file (@files) {
      next if $file =~ /^\.\.?$/;
      next if $file =~ /_vti_cnf/i;
      unlink("$data_directory/ic/$file");
   }
}

sub exit_install_ic {
   my $install_error = shift;
   $install_error = "<br><font color=\"#cccccc\" size=1>Error: $install_error</font>";
   my $install_manual_ic_button = &install_manual_ic_button;
   &die_ic("<b>ImageConvert installation: Automatic installation aborted</b><br>At this moment we were not able to automatic install ImageConvert on your server. Please contact <a href=\"mailto:support\@bizdesign.com\">support\@bizdesign.com</a> or try to install it manually.$install_error", $install_manual_ic_button);
}

sub get_ic {
   &empty_dir_ic;
   my @file = split(/\//, $ic_query);
   my $file = pop(@file);
   my $ic_respond = &if_web_get($ic_query, "$data_directory/ic/$file");
   if ($ic_respond eq "done") {
      &uncompress_ic("$data_directory/ic/$file", "$data_directory/ic");
   }
}

sub proxy_ic_button {
   my ($proxy_address, $proxy_port) = @_;
   my $ic_output = qq|
      <form method="get" action="$imagefolio_url">
      <input type="hidden" name="imageconvert" value="install">
      <input type="hidden" name="set_proxy" value="1">
        <tr>
          <td>
            <table width="100%" border="0" cellspacing="1" cellpadding="1">
              <tr> 
                <td width="50%" nowrap><font class="ic_main"><b>HTTP Proxy address to use</b></font></td>
                <td width="50%" nowrap><font class="ic_main"><b>Port</b></font></td>
              </tr>
              <tr> 
                <td width="50%" nowrap> 
                  <input type="text" name="set_proxy_address" value="$proxy_address" size="40">
                  <font class="ic_main"><b>:</b></font> </td>
                <td width="50%" nowrap> 
                  <input type="text" name="set_proxy_port" value="$proxy_port" size="6" maxlength="6">
                </td>
              </tr>
              <tr> 
                <td colspan="2" align="center">
                  <input type="button" class="ic_button" value="Go Back" onClick="history.go(-1)">
                  <input type="submit" value="Set proxy info" class="ic_button" onClick='this.value="Processing ..."'>
                </td>
              </tr>
            </table>
          </td>
        </tr>
      </form>|;
   return $ic_output;
}

1;
